let crmTabs = [];
chrome.runtime.onStartup.addListener(function () {
	
})
chrome.runtime.onMessage.addListener(function (message, sender, sendResponse) {
	if (message.type) {
		switch (message.type) {
			case 'crmTab':
				crmTabs.push(sender.tab);
			break;
			
			case 'openExtensions':
				//'chrome://extensions/?id=' + chrome.i18n.getMessage("@@extension_id")
				chrome.tabs.create({ 'url': 'chrome://extensions' }, function (tab) {
					sendResponse({
						'type': 'openExtensions',
						'success': true
					});
				});
			break;
			
			case 'passPhoneNumberToCRM':
				let phoneNumber = message.data;
				/*
				for (let i = 0; i < crmTabs.length; i++) {
					try {
						let tabInfo = await browser.tabs.get(crmTabs[i].id);
						console.log(tabInfo);
						chrome.tabs.sendMessage(crmTabs[i].id, {'type': 'callTo', 'data': phoneNumber});
						break;
					} catch (error) {
						console.error(error);
					}
				}
				//*/
				
				chrome.tabs.query({ url: 'https://*.intrumnet.com/crm/tools/*' }, function (tabs) {
					if (tabs.length === 0) {
						/*
						chrome.tabs.create({ 'url': 'https://intrumnet.com/' }, function(tab) {
							chrome.tabs.executeScript(tab.id, {file: "main.js"});
						});
						*/
						sendResponse({
							'type': 'passPhoneNumberToCRM',
							'success': false
						});
					} else {
						let tab = false;
						for (let i = 0; i < tabs.length; i++) {
							if (tabs[i].pinned) {
								tab = tabs[i];
								break;
							}
						}
						
						if (!tab) {
							tab = tabs[tabs.length - 1];
						}
						
						if (tab) {
							chrome.tabs.sendMessage(tabs[0].id, {'type': 'callTo', 'data': phoneNumber});
							chrome.tabs.update(tabs[0].id, {active: true, highlighted: true});
						}
						
						sendResponse({
							'type': 'passPhoneNumberToCRM',
							'success': (tab ? true : false)
						});
					}
				});
			break;
			
			case 'decodePhoneAvito':
				let formData = new FormData();
				formData.append('datapic', JSON.stringify({
					'isAnonym': false,
					'image64': message.data
				}));
				
				console.log('decodePhoneAvito called..');
				
				fetch('https://bazacenter.ru/robot/pic_tel_avito.php', {
					method: 'POST',
					body: formData
				})
				.then(response => response.text())
				.then(function (response) {
					let success = false;
					if (response && response.length) {
						success = true;
					}
					sendResponse({
						'type': 'decodePhoneAvito',
						'success': success,
						'value': response
					});
				})
				.catch(function (error) {
					sendResponse({
						'type': 'decodePhoneAvito',
						'success': false,
						'error': error
					});
				});
			break;
			
			default:
				sendResponse({
					'type': message.type,
					'success': false,
					'error': 'Unknown request type'
				});
			break;
		}
	} else {
		sendResponse({
			'type': 'unknown',
			'success': false,
			'error': 'Unknown request'
		});
	}
	
	return true;
});
