let initCallButton = function (element, phone, mini, addStyle) {
	mini = mini || false;
	addStyle = addStyle || '';
	let nPhone = phone.replace(/\D+/g, '');
	if (nPhone.length === 11) {
		if (nPhone[0] === '8') {
			nPhone = '+7' + nPhone.substr(1);
		} else if (nPhone[0] === '7') {
			nPhone = '+' + nPhone;
		}
	}
	
	let contStyle, imgStyle;
	if (mini) {
		contStyle = 'display: inline-block; margin-left: 5px; line-height: 22px; vertical-align: text-top; position: relative;';
		imgStyle = 'vertical-align: baseline; cursor: pointer; height: 20px;';
	} else {
		contStyle = 'display:inline-block; margin-left:15px; /*line-height:45px;*/ vertical-align: bottom; position: relative;';
		imgStyle = 'vertical-align: middle; cursor: pointer;';
		
		contStyle = 'display: inline-block; margin-left: 5px; vertical-align: middle; position: absolute; line-height: 32px;';
	}
	if (addStyle && addStyle.length) {
		imgStyle += addStyle;
	}
	
	let callIconUrl = chrome.runtime.getURL('images/call-32x32.png');
	let callBlock = htmlToElement(`
		<div style="${contStyle}">\
			<img class="${PREFIX}call_button" src="${callIconUrl}" style="${imgStyle}">
			<div class="${PREFIX}drop_down_list" style="display:none; position: absolute; z-index: 999999; background-color: white; border: 1px solid #ccc; padding: 2px 2px; font-size: 14px; font-style: normal; font-weight: normal; text-align: left;">
				<div class="${PREFIX}call_element ${PREFIX}copy_to_clipboard" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Копировать номер</div>
				<a class="${PREFIX}call_a_element" href="tel:${nPhone}" style="color: #000; text-decoration: none;"><div class="${PREFIX}call_element" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Позвонить</div></a>
				<div class="${PREFIX}call_element ${PREFIX}pass_to_crm" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Позвонить через CRM</div>
			</div>
		</div>\
	`);
	let dropDownMenu = callBlock.querySelectorAll(`.${PREFIX}drop_down_list`)[0];
	
	callBlock.querySelectorAll('img')[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		let target = e.target || e.srcElement;
		dropDownMenu.style.display = 'block';
		
		popupPositioning(dropDownMenu);
		
	}, false);
	
	callBlock.querySelectorAll(`.${PREFIX}copy_to_clipboard`)[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		copyToClipboard(nPhone);
	});
	
	callBlock.querySelectorAll(`.${PREFIX}pass_to_crm`)[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		chrome.runtime.sendMessage({
			type: 'passPhoneNumberToCRM',
			data: nPhone
		}, function (response) {
			
		});
	});
	
	element.style.whiteSpace = 'nowrap';
	element.disabled = true;
	//element.appendChild(callBlock);
	element.parentNode.appendChild(callBlock);

	element.style.display = 'inline-block';

	if (mini) {
		element.style.lineHeight = '25px';
		let simplePhoneButton = element.parentNode.parentNode;
		simplePhoneButton.style.height = 'auto';
		
		if (simplePhoneButton.parentNode.parentNode.getAttribute('data-name') === 'TopButtons') {
			simplePhoneButton.parentNode.style.height = '32px';
		}
	}
}

let createObserver = function (options) {
	let selectorHidden = options.phoneElem.hidden;
	let selectorShown = options.phoneElem.shown;
	
	if (selectorHidden.constructor === Array) {
		selectorHidden = selectorHidden.join(',');
	}
	if (selectorShown.constructor === Array) {
		selectorShown = selectorShown.join(',');
	}
	
	let callButtons = document.querySelectorAll(selectorHidden);
	if (callButtons.length > 0) {
		var observer = new MutationObserver(function (mutations) {
			let phones = document.querySelectorAll(selectorShown);
			if (phones.length > 0) {
				for (let i = 0; i < phones.length; i++) {
					let phone = phones[i];
					if (phone.hasOwnProperty('crmReady')) continue;
					phone.crmReady = true;
					if (phone.querySelectorAll(`.${PREFIX}call_button`).length > 0) continue;
					
					if (options.skip && options.skip.length) {
						let skipFired = false;
						for (let c = 0; c < options.skip.length; c++) {
							skipFired = skipFired || options.skip[c](phone);
						}
						if (skipFired) continue;
					}
					
					let placeToElem = phone;
					if (options.icon && options.icon.preprocessElem && typeof options.icon.preprocessElem === 'function') {
						placeToElem = options.icon.preprocessElem(placeToElem);
					}
					
					try {
						chrome.runtime.sendMessage({
							type: 'decodePhoneAvito',
							data: phone[ options.phoneElem.property ]
						}, function (response) {
							if (response.success && !response.error) {
								initCallButton(placeToElem, response.value, options.icon.isMini, options.icon.style);
								
								if (options.icon && options.icon.postprocessElem && typeof options.icon.postprocessElem === 'function') {
									options.icon.postprocessElem(placeToElem);
								}
							}
						});
					} catch (e) {
						// TODO:
					}
				}
			}
		});
		
		let observerOptions = options.observerOptions || { childList: true, subtree: true };
		observer.observe(document.body, observerOptions);
	} else {
		if (typeof options.isWrong === 'function' && options.isWrong()) {
			somethingWrong();
		}
	}
}

let replacments = [{
	// Страница списка объявлений
	'observerOptions': { childList: true, subtree: true },
	'phoneElem': {
		'hidden': '[data-marker="catalog-serp"] [data-marker="item"] button[data-marker^="item-phone-button"]', // [data-test="OfferCardSummary"] [class^="OfferCardContacts__container"] button[data-test="OfferCardContactsPhoneButton"]
		'shown': `[data-marker="catalog-serp"] [data-marker="item"] [class^="phone-button-root"] img[class^="button-phone-image"]:not(.${PREFIX}call_a_element)`,
		'property': 'src'
	},
	'icon': {
		'isMini': true,
		'style': 'margin-top: 4px;',
		'preprocessElem': false
	},
	'skip': [
		//function (elem) { return (elem.style.whiteSpace === 'nowrap'); },
		function (elem) { return (elem.textContent.indexOf('Показать') != -1); }
	],
	'isWrong': false
}, { // Страница объявления
	'observerOptions': { childList: true, subtree: true },
	'phoneElem': {
		'hidden': [
			'[data-marker="item-phone-button/card"]',
			'[data-marker="item-popup/popup"]',
			//'[data-marker="development-offers/carousel/phone-button"]',
			'[data-marker="item-view/item-view-contacts"]'
		],
		'shown': [
			`[data-marker="item-popup/content"] [data-marker="phone-popup/phone-image"]:not(.${PREFIX}call_a_element)`,
			`[data-marker="item-popup/popup"] [data-marker="phone-popup/phone-image"]:not(.${PREFIX}call_a_element)`,
			//`[data-marker="developer-phone-popup/content"] [alt="phone"][class^="development-offers-phone"]:not(.${PREFIX}call_a_element)`,
			`[data-marker="item-view/item-view-contacts"] [data-marker="item-phone-button/card"] img[data-marker="phone-image"]:not(.${PREFIX}call_a_element)`,
		],
		'property': 'src'
	},
	'icon': {
		'isMini': false,
		'preprocessElem': false,
		'style': 'vertical-align: top; cursor: pointer;', // margin-top: -16px;
		'postprocessElem': function (elem) {
			if (elem.attributes['data-marker'].value === 'phone-image') {
				elem.nextSibling.style.marginTop = '3px';
			}
		}
	},
	'skip': [
		function (elem) { return (elem.style.whiteSpace === 'nowrap'); },
		function (elem) { return (elem.textContent.indexOf('Показать') != -1); }
	],
	'isWrong': false
}];

function checkAndInitObservers() {
	if (document.querySelectorAll('[class^="style-item-view"][data-marker="item-view/item-view-contacts"]').length || document.querySelectorAll('[class^="items-items"][data-marker="catalog-serp"]').length) {
		replacments.forEach(a => createObserver(a));
	} else {
		setTimeout(checkAndInitObservers, 1000);
	}
}
setTimeout(checkAndInitObservers, 1000);


