let initCallButton = function (element, phone, mini, addStyle) {
	mini = mini || false;
	addStyle = addStyle || '';
	let nPhone = phone.replace(/\D+/g, '');
	if (nPhone.length === 11) {
		if (nPhone[0] === '8') {
			nPhone = '+7' + nPhone.substr(1);
		} else if (nPhone[0] === '7') {
			nPhone = '+' + nPhone;
		}
	}
	
	let contStyle, imgStyle;
	if (mini) {
		contStyle = 'display: inline-block; margin-left: 5px; line-height: 22px; vertical-align: text-top; position: relative;';
		imgStyle = 'vertical-align: baseline; cursor: pointer; height: 20px;';
	} else {
		contStyle = 'display:inline-block; margin-left:15px; /*line-height:45px;*/ vertical-align: bottom; position: relative;';
		imgStyle = 'vertical-align: middle; cursor: pointer;';
	}
	if (addStyle && addStyle.length) {
		imgStyle += addStyle;
	}
	
	let callIconUrl = chrome.runtime.getURL('images/call-32x32.png');
	let callBlock = htmlToElement(`
		<div style="${contStyle}">\
			<img class="${PREFIX}call_button" src="${callIconUrl}" style="${imgStyle}">
			<div class="${PREFIX}drop_down_list" style="display:none; position: absolute; z-index: 999999; background-color: white; border: 1px solid #ccc; padding: 2px 2px; font-size: 14px; font-style: normal; font-weight: normal; text-align: left;">
				<div class="${PREFIX}call_element ${PREFIX}copy_to_clipboard" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Копировать номер</div>
				<a class="${PREFIX}call_a_element" href="tel:${nPhone}" style="color: #000; text-decoration: none;"><div class="${PREFIX}call_element" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Позвонить</div></a>
				<div class="${PREFIX}call_element ${PREFIX}pass_to_crm" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Позвонить через CRM</div>
			</div>
		</div>\
	`);
	let dropDownMenu = callBlock.querySelectorAll(`.${PREFIX}drop_down_list`)[0];
	
	callBlock.querySelectorAll('img')[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		let target = e.target || e.srcElement;
		dropDownMenu.style.display = 'block';
		
		popupPositioning(dropDownMenu);
		
	}, false);
	
	callBlock.querySelectorAll(`.${PREFIX}copy_to_clipboard`)[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		copyToClipboard(nPhone);
	});
	
	callBlock.querySelectorAll(`.${PREFIX}pass_to_crm`)[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		chrome.runtime.sendMessage({
			type: 'passPhoneNumberToCRM',
			data: nPhone
		}, function (response) {
			
		});
	});
	
	element.style.whiteSpace = 'nowrap';
	element.disabled = true;
	element.appendChild(callBlock);
	
	if (mini) {
		element.style.lineHeight = '25px';
		let simplePhoneButton = element.parentNode.parentNode;
		simplePhoneButton.style.height = 'auto';
		
		if (simplePhoneButton.parentNode.parentNode.getAttribute('data-name') === 'TopButtons') {
			simplePhoneButton.parentNode.style.height = '32px';
		}
	}
}

let createObserver = function (options) {
	let selectorHidden = options.phoneElem.hidden;
	let selectorShown = options.phoneElem.shown;
	
	if (selectorHidden.constructor === Array) {
		selectorHidden = selectorHidden.join(',');
	}
	if (selectorShown.constructor === Array) {
		selectorShown = selectorShown.join(',');
	}
	
	let callButtons = document.querySelectorAll(selectorHidden);
	if (callButtons.length > 0) {
		var observer = new MutationObserver(function (mutations) {
			let phones = document.querySelectorAll(selectorShown);
			if (phones.length > 0) {
				for (let i = 0; i < phones.length; i++) {
					let phone = phones[i];
					if (phone.hasOwnProperty('crmReady')) continue;
					phone.crmReady = true;
					if (phone.querySelectorAll(`.${PREFIX}call_button`).length > 0) continue;
					
					if (options.skip && options.skip.length) {
						let skipFired = false;
						for (let c = 0; c < options.skip.length; c++) {
							skipFired = skipFired || options.skip[c](phone);
						}
						if (skipFired) continue;
					}
					
					initCallButton(phone, phone[ options.phoneElem.property ], options.icon.isMini, options.icon.style);
				}
			}
		});
		observer.observe(document.body, { childList: true, subtree: true });
	} else {
		if (typeof options.isWrong === 'function' && options.isWrong()) {
			somethingWrong();
		}
	}
}

let replacments = [{
	// Страница объявления. Правый блок
	'phoneElem': {
		'hidden': [
			'[data-name="OfferCardAside"] button[class*=--button--]',
			'[data-name="OfferContactsAside"] button[class*=--button--]'
		],
		'shown': [
			`[data-name="OfferCardAside"] [data-name="PhonesOpenedInfo"] a[href^=tel]:not(.${PREFIX}call_a_element)`,
			`[data-name="OfferContactsAside"] [class*="--phones--"] a[href^=tel]:not(.${PREFIX}call_a_element)`
		],
		'property': 'href'
	},
	'icon': {
		'isMini': false,
		'style': false
	},
	'skip': [
		function (elem) { return (elem.style.whiteSpace === 'nowrap'); }
	],
	'isWrong': function () {
		if (document.querySelectorAll('section[data-name="Main"]').length) {
			if (!document.querySelectorAll('[data-name="OfferUnpublished"]').length) {
				return true;
			}
		}
		return false;
	}
}, { // Страница списка объявлений. Правый блок
	'phoneElem': {
		'hidden': [
			'[data-name="ContactActionsLayout"] button[class*=--button--]',
			'[data-name="CardComponent"] button[class*=--button--]'
		],
		'shown': [
			'[data-name="ContactActionsLayout"] span[data-mark="PhoneValue"]',
			'[data-name="CardComponent"] span[data-mark="PhoneValue"]'
		],
		'property': 'textContent'
	},
	'icon': {
		'isMini': true,
		'style': false
	},
	'isWrong': function () {
		if (document.querySelectorAll('#legacy-commercial-serp-frontend').length) {
			return true;
		}
		return false;
	}
}, { // Страница объявления. Нижний левый блок
	'phoneElem': {
		'hidden': [
			'[data-name="HomeownerInfo"] button[class*=--button--]',
			'[data-name="DeveloperInfo"] button[class*=--button--]',
			'[data-name="ContactsMain"] button[class*=--button--]'
		],
		'shown': [
			`[data-name="HomeownerInfo"] [data-name="PhonesOpenedInfo"] a[href^=tel]:not(.${PREFIX}call_a_element)`,
			`[data-name="DeveloperInfo"] [data-name="PhonesOpenedInfo"] a[href^=tel]:not(.${PREFIX}call_a_element)`,
			`[data-name="ContactsMain"] span[class*=--phones--]:not(.${PREFIX}call_a_element)`
		],
		'property': 'textContent'
	},
	'icon': {
		'isMini': true,
		'style': 'vertical-align: middle; margin-top:5px;'
	},
	'isWrong': function () {
		if (document.querySelectorAll('#legacy-commercial-serp-frontend').length) {
			return true;
		}
		return false;
	}
}, { // Страница объявления. Верхняя панель
	'phoneElem': {
		'hidden': '[data-name="Navigation"] button[class*=--button--]',
		'shown': `[data-name="Navigation"] [data-name="CallButtonContainer"] a[href^=tel]:not(.${PREFIX}call_a_element)`,
		'property': 'textContent'
	},
	'icon': {
		'isMini': true,
		'style': 'margin-top:2px;'
	},
	'isWrong': function () {
		if (document.querySelectorAll('#legacy-commercial-serp-frontend').length) {
			return true;
		}
		return false;
	}
}];

replacments.forEach(a => createObserver(a));
