let initCallButton = function (element, phone, mini, addStyle) {
	mini = mini || false;
	addStyle = addStyle || '';
	let nPhone = phone.replace(/\D+/g, '');
	if (nPhone.length === 11) {
		if (nPhone[0] === '8') {
			nPhone = '+7' + nPhone.substr(1);
		} else if (nPhone[0] === '7') {
			nPhone = '+' + nPhone;
		}
	}
	
	let contStyle, imgStyle;
	if (mini) {
		contStyle = 'display: inline-block; margin-left: 5px; line-height: 22px; vertical-align: text-top; position: relative;';
		imgStyle = 'vertical-align: baseline; cursor: pointer; height: 20px;';
	} else {
		contStyle = 'display:inline-block; margin-left:15px; /*line-height:45px;*/ vertical-align: bottom; position: relative;';
		imgStyle = 'vertical-align: middle; cursor: pointer;';
	}
	if (addStyle && addStyle.length) {
		imgStyle += addStyle;
	}
	
	let callIconUrl = chrome.runtime.getURL('images/call-32x32.png');
	let callBlock = htmlToElement(`
		<div style="${contStyle}">\
			<img class="${PREFIX}call_button" src="${callIconUrl}" style="${imgStyle}">
			<div class="${PREFIX}drop_down_list" style="display:none; position: absolute; z-index: 999999; background-color: white; border: 1px solid #ccc; padding: 2px 2px; font-size: 14px; font-style: normal; font-weight: normal; text-align: left;">
				<div class="${PREFIX}call_element ${PREFIX}copy_to_clipboard" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Копировать номер</div>
				<a class="${PREFIX}call_a_element" href="tel:${nPhone}" style="color: #000; text-decoration: none;"><div class="${PREFIX}call_element" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Позвонить</div></a>
				<div class="${PREFIX}call_element ${PREFIX}pass_to_crm" style="white-space: nowrap; line-height: 30px; padding: 0 5px; user-select: none; cursor: pointer;">Позвонить через CRM</div>
			</div>
		</div>\
	`);
	let dropDownMenu = callBlock.querySelectorAll(`.${PREFIX}drop_down_list`)[0];
	
	callBlock.querySelectorAll('img')[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		let target = e.target || e.srcElement;
		dropDownMenu.style.display = 'block';
		
		popupPositioning(dropDownMenu);
		
	}, false);
	
	callBlock.querySelectorAll(`.${PREFIX}copy_to_clipboard`)[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		copyToClipboard(nPhone);
	});
	
	callBlock.querySelectorAll(`.${PREFIX}pass_to_crm`)[0].addEventListener('click', function (e) {
		e = e || window.event;
		e.stopPropagation();
		e.preventDefault();
		
		hideAllDropDownMenus();
		
		chrome.runtime.sendMessage({
			type: 'passPhoneNumberToCRM',
			data: nPhone
		}, function (response) {
			
		});
	});
	
	element.backup = element.backup || {};
	element.backup.style = element.backup.style || {};
	element.backup.style.whiteSpace = element.style.whiteSpace;
	
	element.style.whiteSpace = 'nowrap';
	element.disabled = true;
	element.appendChild(callBlock);
	
	if (mini) {
		element.style.lineHeight = '25px';
		let simplePhoneButton = element.parentNode.parentNode;
		simplePhoneButton.style.height = 'auto';
		
		if (simplePhoneButton.parentNode.parentNode.getAttribute('data-name') === 'TopButtons') {
			simplePhoneButton.parentNode.style.height = '32px';
		}
	}
}

let createObserver = function (options) {
	let selectorHidden = options.phoneElem.hidden;
	let selectorShown = options.phoneElem.shown;
	
	if (selectorHidden.constructor === Array) {
		selectorHidden = selectorHidden.join(',');
	}
	if (selectorShown.constructor === Array) {
		selectorShown = selectorShown.join(',');
	}
	
	let callButtons = document.querySelectorAll(selectorHidden);
	if (callButtons.length > 0) {
		var observer = new MutationObserver(function (mutations) {
			let phones = document.querySelectorAll(selectorShown);
			if (phones.length > 0) {
				for (let i = 0; i < phones.length; i++) {
					let phone = phones[i];
					if (phone.hasOwnProperty('crmReady')) continue;
					phone.crmReady = true;
					if (phone.querySelectorAll(`.${PREFIX}call_button`).length > 0) continue;
					
					if (options.skip && options.skip.length) {
						let skipFired = false;
						for (let c = 0; c < options.skip.length; c++) {
							skipFired = skipFired || options.skip[c](phone);
						}
						if (skipFired) continue;
					}
					
					let placeToElem = phone;
					if (options.icon && options.icon.preprocessElem && typeof options.icon.preprocessElem === 'function') {
						placeToElem = options.icon.preprocessElem(placeToElem);
					}
					
					initCallButton(placeToElem, phone[ options.phoneElem.property ], options.icon.isMini, options.icon.style);
					
					if (options.icon && options.icon.postprocessElem && typeof options.icon.postprocessElem === 'function') {
						options.icon.postprocessElem(placeToElem);
					}
				}
			}
		});
		
		let observerOptions = options.observerOptions || { childList: true, subtree: true };
		observer.observe(document.body, observerOptions);
	} else {
		if (typeof options.isWrong === 'function' && options.isWrong()) {
			somethingWrong();
		}
	}
}

let replacments = [{
	// Страница списка объявлений
	'observerOptions': { childList: true, subtree: true, attributes: true },
	'phoneElem': {
		'hidden': '[data-test="product-snippet"] button[data-e2e-id="show-phone-button"]',
		'shown': `[data-test="product-snippet"] button[data-e2e-id="show-phone-number"]:not(.${PREFIX}call_a_element)`, //  span
		'property': 'textContent'
	},
	'icon': {
		'isMini': false,
		'style': 'margin-left:-10px; margin-top: 4px;',
		'preprocessElem': function (elem) {
			return elem.parentElement;
		}
	},
	'skip': [
		function (elem) { return (elem.style.whiteSpace === 'nowrap'); },
		function (elem) { return (elem.textContent.indexOf('Показать') != -1); }
	],
	'isWrong': false
}, { // Страница объявления
	'observerOptions': { childList: true, subtree: true, attributes: true },
	'phoneElem': {
		'hidden': [
			'.product-page__sticky button[data-e2e-id="agent-show-number"]',
			'.shell_railedContentSidebarContent .telephony_developerContactButton > button'
		],
		'shown': [
			`.product-page__sticky a[data-e2e-id="agent-show-number"]:not(.${PREFIX}call_a_element)`, //  span
			`.shell_railedContentSidebarContent .telephony_developerContactButton > a[role="button"]:not(.${PREFIX}call_a_element)`
		],
		'property': 'textContent'
	},
	'icon': {
		'isMini': false,
		'style': 'margin-left:-5px; display: inline-block;',
		'preprocessElem': function (elem) {
			let elemParent = elem.parentElement;
			let elemDivContainer = htmlToElement('<div></div>');
			elemParent.insertBefore(elemDivContainer, elem);
			elemDivContainer.append(elem);
			
			elem.style.width = 'calc(100% - 40px)';
			
			return elemDivContainer;
		},
		'postprocessElem': function (elem) {
			let parent = elem.parentElement.querySelectorAll(`img.${PREFIX}call_button`)[0].parentElement;
			parent.style.lineHeight = '52px';
		}
	},
	'skip': [
		function (elem) { return (elem.style.whiteSpace === 'nowrap'); },
		function (elem) { return (elem.textContent.indexOf('Показать') != -1); }
	],
	'isWrong': false
}];

replacments.forEach(a => createObserver(a));
